package util;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Random;

import javax.imageio.ImageIO;

import org.uncommons.maths.random.MersenneTwisterRNG;

import calculation.Agent;

public class utils {
	public static double X;

	public static int N;
	public static int type_count;
	public static int lattice_size;
	public static int neighborhood_type;
	public static int distance;

	public static double mutant_probability=0.1;
	public static double density;

	public static double sigma=0.0001;
	public static double m_sigma=0.1;
	public static double move_probability=0.0;
	public static boolean tag_move_flag=true;
	public static final Color color_set[]={Color.decode("#AA0000"),Color.decode("#00AA00"),Color.white};
	public static final int MOORE_NEIGHBORHOOD=0;
	public static final int NEUMANN_NEIGHBORHOOD=1;
	public static void setLattice(int ls){
		byte[] seed=new byte[16];r= new Random();
		r.nextBytes(seed);
		r.nextBytes(seed);
		r=new MersenneTwisterRNG(seed);
		lattice_size=ls;
	}
	public static void showDbgStr(){
		System.out.println("debug");
	}
	public static void setGame(double x){
		X=x;
	}
	public static void setSigma(double s,double m_s){
		sigma=s;
		m_sigma=m_s;
	}
	public static void setTag_number(int t){
		type_count=t;
	}
	public static void setNeighborType(int t){
		neighborhood_type=t;
	}
	public static void setDistance(int d){
		distance=d;
	}
	public static void setDensity(double d){
		density=d;
		N=(int)((lattice_size*lattice_size)*d);
	}
	public static void setMove_probability(double p){
		tag_move_flag=false;
		move_probability=p;
	}
	public static int getIndex(int a){
		if(a<0)a+=lattice_size;
		return a%lattice_size;
	}
	public static int getIndex(int x,int y){
		return y*lattice_size+x;
	}
	public static Random r;
	public static boolean isOccured(double probability){
		return r.nextDouble()<probability;
	}
	public static final int image_times=4;

	public static BufferedImage getBitmap(Agent[][] data,int type){
		BufferedImage image=new BufferedImage(lattice_size,lattice_size,BufferedImage.TYPE_INT_RGB);
		for(int x=lattice_size-1;x>-1;x--){
			for(int y=lattice_size-1;y>-1;y--){
				image.setRGB(x,y,((data[x][y]!=null)?getColor(data[x][y],type).getRGB():color_set[2].getRGB()));
			}
		}
		return image;
	}
	public static Color getColor(Agent a,int type){
		switch(type){
			case 0:
				if(type_count==2)return color_set[a.TAG];
				return getColor(a.TAG);
			case 1:
				return getColor(a.strategy[0]);
			case 2:
				return getColor(a.strategy[1]);
			case 3:
				return getColorByEta(a.eta);
		}
		return color_set[2];
	}
	public static Color getColor(int tag){
		return new Color(Color.HSBtoRGB(1-(float)tag/type_count,1f,0.8f));
	}
	public static Color getColor(double strategy){
		return new Color(Color.HSBtoRGB(1-(float)strategy/3,1f,1f));
	}
	public static Color getColorByEta(double eta){
		return new Color(Color.HSBtoRGB(1-(float)(eta+1)/6,1f,1f));
	}

	public static BufferedImage getBitmap(BufferedImage... a){
		int size=lattice_size*image_times;
		BufferedImage jointimage=new BufferedImage((size+image_times)*a.length-image_times,size,BufferedImage.TYPE_INT_RGB);
		Graphics g=jointimage.getGraphics();
		for(int i=0;i<a.length;i++){
			g.drawImage(a[i],size*i+image_times*i,0,size,size,null);
			g.setColor(Color.black);
			if(i!=a.length-1)g.drawRect(size*(i+1)+image_times*i, 0, image_times, size);
		}
		return jointimage;
	}
	//TODO not implement
	public static boolean saveImage(BufferedImage image,String fileName){
		try{
			OutputStream out=new FileOutputStream(fileName);
			ImageIO.write(image,"bmp", out);
			out.close();
			return true;
		}catch(IOException e){
			System.out.println("Err="+e);
			return false;
		}
	}
}
